#ifndef __CSQUARESPRITE_H__
#define __CSQUARESPRITE_H__

#include <sps2lib.h>
#include <sps2tags.h>
#include <sps2regstructs.h>
#include <sps2util.h>
#include <assert.h>
#include "PS2Defines.h"
#include "AddRegisters.h"

class CSquareSprite
{
public:
	CSquareSprite( int xTexture, int yTexture, int widthTexture, int heightTexture);
	~CSquareSprite();

	void CSquareSprite::setPos(int xPos, int yPos);
	void CSquareSprite::setTexturePos(int xTexturePos, int yTexturePos);
	void CSquareSprite::movePos(int xPos, int yPos);
	void CSquareSprite::setVisible(bool isVisible);
	void CSquareSprite::setColor(int Red, int Green, int Blue, int Alpha);

	bool CSquareSprite::getVisible(void);
	int CSquareSprite::getXPos(void);
	int CSquareSprite::getYPos(void);
	int CSquareSprite::getWidth(void);
	int CSquareSprite::getHeight(void);
	bool CSquareSprite::inside(CSquareSprite inSprite);

	void CSquareSprite::addSpriteToGIFTag(char *& pMem, int Zvalue);
	void CSquareSprite::addSpriteToMem(char *& pMem, int Zvalue);
	static void CSquareSprite::setSpriteOffset(void);


	void CSquareSprite::setCustomInt1(int value);
	void CSquareSprite::setCustomInt2(int value);
	void CSquareSprite::setCustomInt3(int value);
	void CSquareSprite::setCustomInt4(int value);
	void CSquareSprite::setCustomInt5(int value);
	void CSquareSprite::setCustomFloat1(float value);
	void CSquareSprite::setCustomFloat2(float value);
	void CSquareSprite::setCustomFloat3(float value);
	void CSquareSprite::setCustomFloat4(float value);
	void CSquareSprite::setCustomFloat5(float value);

	int CSquareSprite::getCustomInt1();
	int CSquareSprite::getCustomInt2();
	int CSquareSprite::getCustomInt3();
	int CSquareSprite::getCustomInt4();
	int CSquareSprite::getCustomInt5();
	float CSquareSprite::getCustomFloat1();
	float CSquareSprite::getCustomFloat2();
	float CSquareSprite::getCustomFloat3();
	float CSquareSprite::getCustomFloat4();
	float CSquareSprite::getCustomFloat5();

	void CSquareSprite::animationUpdate(void);
	void CSquareSprite::animationSetTextureDirection(int dir);
	void CSquareSprite::animationSetFramesInAnimation(int frames);
	void CSquareSprite::animationSetFramePos(int pos);
	void CSquareSprite::animationSetFrameRepeat(int loop);
	void CSquareSprite::animationSetFrameRepeatBackAndForth(int backAndForth);
	void CSquareSprite::animationSetFrameDelay(int delay);

private:
	int m_xTexture, m_yTexture;
	int m_widthTexture, m_heightTexture;
	int m_xPos, m_yPos;
	static int m_xOffset, m_yOffset;
	int m_Red, m_Green, m_Blue, m_Alpha;
	int m_xTexturePos, m_yTexturePos;
	bool m_isVisible;

	int m_iCustom1;
	int m_iCustom2;
	int m_iCustom3;
	int m_iCustom4;
	int m_iCustom5;
	float m_fCustom1;
	float m_fCustom2;
	float m_fCustom3;
	float m_fCustom4;
	float m_fCustom5;

	int m_iAnimationDirectionTexture;
	int m_iAnimationFramesInAnimation;
	int m_iAnimationDirectionOfFrame;
	int m_iAnimationFramePos;
	int m_iAnimationFrameRepeat;
	int m_iAnimationFrameRepeatBackAndForth;
	int m_iAnimationFrameDelay;
	int m_iAnimationFrameDelayCounter;

	
};


int CSquareSprite::m_xOffset;
int CSquareSprite::m_yOffset;

#endif
